Attribute VB_Name = "Module1"
Option Explicit

  '      
  Dim acSelSet As AcadSelectionSet
  Dim intCnt As Integer
  Dim objArray(0) As Object
  Dim AnyObj As AcadEntity
  Dim AnyPnt As Variant
  Dim mode As Integer
  '   3DPolylines,    XYZ 
  '   Polylines,     XY   Z=0
  '   
  Dim intVCnt As Integer
  Dim intFile1 As Integer
  Dim intFile2 As Integer
  Dim strFileName As String
  Dim strVert As String
  Dim strVert2 As String
  Dim retCoord As Variant
  '  3D-
  Dim pline3dObj As Acad3DPolyline
  '  2D-, ..  LWPolyLines
  Dim plineObj As AcadLWPolyline
  '  Point,  XYZ 
  Dim pointObj As AcadPoint
  '  
  Dim textObj As AcadText
  Dim textString As String
  Dim curInsPnt As Variant
  '  , ..  Lines
  Dim lineObj As AcadLine
  Dim retCoordStart As Variant
  Dim retCoordEnd As Variant
  Dim startPoint As Variant
  Dim endPoint As Variant

  Dim intCnt2 As Variant
  Dim varVert As Variant
  Dim varPnt As Variant
  Dim varCord As Variant
  Dim intCrdCnt As Integer
  Dim strInfo As String
  Dim strLayer As String
  Dim intPntNum As Integer
  Dim i As Integer
  '     ()   ,
  '     dataValue(0) =  acSelSet.Select_mode,
  Dim gpCode(0) As Integer
  Dim dataValue(0) As Variant
  Dim groupCode As Variant, dataCode As Variant

  '   TEXT
  Dim InputString As String
  '       
  Dim PointSymbol As String
  '   LWPolylines  Elevation  "0"  " 0"
  Dim codePnt As String
  Dim codeRel As String
'======================================================

Public Declare Function GetOpenFileName Lib "comdlg32.dll" _
Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Type OPENFILENAME
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type
'----------------------------------------------------------
' Display and use the File open dialog
Public Function ShowOpen() As String
  Dim strTemp As String
  Dim VertName As OPENFILENAME
  VertName.lStructSize = Len(VertName)
  VertName.hwndOwner = ThisDrawing.HWND
  VertName.lpstrFilter = "CREDO-TER Files (*.*)" + Chr$(0) + _
                         "*.*" + Chr$(0)
  VertName.lpstrFile = Space$(254)
  VertName.nMaxFile = 255
  VertName.lpstrFileTitle = Space$(254)
  VertName.nMaxFileTitle = 255
  VertName.lpstrInitialDir = CurDir
  VertName.lpstrTitle = "      *.TOP  *.ABR"
  VertName.flags = 0
  If GetOpenFileName(VertName) Then
    strTemp = (Trim(VertName.lpstrFile))
    ShowOpen = Mid(strTemp, 1, Len(strTemp) - 1)
  End If
End Function
'----------------------------------------------------------
' Round it to any place you need, Jon.  ,  ,  ,  .
Private Function vbdRoundToDecimal(dblNumber As Variant, _
intPlace As Integer) As Double
  Dim dblDecimal As Double
  dblDecimal = 10 ^ intPlace
  vbdRoundToDecimal = Int(dblNumber * dblDecimal + 0.005) / dblDecimal
End Function
'----------------------------------------------------------
Public Sub FindPointSymbol()
   '        
  Dim CurrentEntryIndex As Long
  Dim Char As String  '  
  Dim TextLen As Integer '   
  Dim i As Integer ' 
  CurrentEntryIndex = 1
  PointSymbol = ""
  '    <5  >7  -    ,
  '       1.500  1500.30,
  '    ,    .
  '    6- ,    .
  If Len(InputString) < 5 And Len(InputString) > 8 Then
      Exit Sub
  End If
  TextLen = Len(InputString)
  '     (  ).
  '         -
  '  3-  4- ,    .
  For i = 1 To TextLen
  Char = Mid(InputString, CurrentEntryIndex, 1)
      '       "."  ","     
      '   SUB   PointSymbol
      If Char < "0" Or Char > "9" And (Char <> "." Or Char <> ",") Then
      PointSymbol = ""
      Exit Sub
      End If
      If Char = "." Or Char = "," Then
      PointSymbol = Char
      Else
      CurrentEntryIndex = CurrentEntryIndex + 1
      End If
  Next
End Sub
'----------------------------------------------------------
Sub ChangeLayerName()
  '       
  '    
  Dim objLayer As AcadLayer
  Dim iCount As Integer
  iCount = 1
  For Each objLayer In ThisDrawing.Layers
    '  "0"  ,    
    If objLayer.Name <> "0" Then
    objLayer.Name = CStr(iCount) & "_" & objLayer.Name
    iCount = iCount + 1
    End If
  Next
End Sub
'----------------------------------------------------------
Sub RestoreLayerName()
  '       
  '    
  Dim objLayer As AcadLayer
  Dim iCount As Integer
  Dim intLenName As Integer
  Dim CurIndex As Integer
  Dim Char As String
  
  iCount = 1
  CurIndex = 1
  For Each objLayer In ThisDrawing.Layers
    '  "0"  ,    
    If objLayer.Name <> "0" Then
    intLenName = Len(objLayer.Name)
      For iCount = 1 To 4
      Char = Mid(objLayer.Name, CurIndex, 1)
      If Char = "_" Then
         Exit For
      End If
      strLayer = strLayer + Char
      CurIndex = CurIndex + 1
      Next
    objLayer.Name = Right(objLayer.Name, (intLenName - CurIndex))
    End If
  Next
End Sub
'----------------------------------------------------------
Public Sub ExportLayerName(strInfo)
  '        .
  '        
  '       
  '   
  Dim iCount As Integer
  Dim CurIndex As Integer
  Dim Char As String
  '     
  '       
  strLayer = ""
  CurIndex = 1
  
  For iCount = 1 To 4
      If strInfo = "0" Then
         strLayer = strInfo
         Exit For
      End If
      Char = Mid(strInfo, CurIndex, 1)
      If Char = "_" Then
         Exit For
      End If
      strLayer = strLayer + Char
      CurIndex = CurIndex + 1
  Next
End Sub
'----------------------------------------------------------
Sub ChangeSeparator()
  ' Windows     
  '       ","  CREDO
  '   DOS  "."
  '      ","  ".".
  Dim iCount As Integer
  Dim TextLen As Integer
  Dim Char As String
  Dim New_strVert As String
  
  New_strVert = ""
  TextLen = Len(strVert)

  For iCount = 1 To TextLen
  Char = Mid(strVert, iCount, 1)
      If Char = "," Then
         Char = "."
      End If
  New_strVert = New_strVert + Char
  Next
  strVert = New_strVert
End Sub
'----------------------------------------------------------
'       
'      -  
'         -
Public Sub ExportACADtoCREDO()
    '      ,      :
    MsgBox "Export_ACAD_to_CREDO - -   Credo-TER(MIX)   AutoCAD DWG-." _
    & vbCrLf & "    :   AutoCAD'   MsgBox.   !" _
    & vbCrLf & "  2  -: *.top  *.abr,       ," _
    & vbCrLf & ",      ().      ,  " _
    & vbCrLf & "   1,2,..., 999,    .     AutoCAD.  " _
    & vbCrLf & "    ,        .  :  , " _
    & vbCrLf & "   -   ,     -  .      . " _
    & vbCrLf & "  ,           178.35,   ,  ." _
    & vbCrLf & " " _
    & vbCrLf & " " _
    & vbCrLf & " , , sklimkin@comail.ru ", vbExclamation
 
 '==========================================================================
  ' 0-  -        :
 '==========================================================================
  '      - TOP  ABR
  '    ,      
  intFile1 = FreeFile
  ' ! ,     *.TOP
  strFileName = ShowOpen
  If Not Right(strFileName, 4) = ".top" Then
    strFileName = strFileName & ".top"
  End If
  Open strFileName For Append As intFile1
  '    ,      
  intFile2 = FreeFile
  ' ! ,     *.ABR
  strFileName = ShowOpen
  If Not Right(strFileName, 4) = ".abr" Then
    strFileName = strFileName & ".abr"
  End If
  Open strFileName For Append As intFile2
  '   -   
  ChangeLayerName
 '======================================================
  ' 1-  -  3D-:
 '======================================================
    '      for_CREDO
  Set acSelSet = ThisDrawing.SelectionSets.Add("for_CREDO")
  '   -  (All) - VBA    
  '  ,     
  mode = acSelectionSetAll
  '     SelectionSet
  acSelSet.Select mode
  '    ( : , Entityes)
  intCnt = acSelSet.Count
  '     
  MsgBox "   " & intCnt & " ." _
  & vbCrLf & "   3D-..."
  '      
  ThisDrawing.SelectionSets.Item("for_CREDO").Clear

  '      3DPolyline !!!
  gpCode(0) = 0
   dataValue(0) = "Polyline"

  groupCode = gpCode
  dataCode = dataValue

  ' acSelSet.Select mode, groupCode, dataCode
  acSelSet.SelectOnScreen groupCode, dataCode
  '    
  intCnt = acSelSet.Count
  MsgBox "  " & intCnt & " 3D-Polyline "
  intCnt2 = 1
   
  ' Print #intFile1, " CREDO-TER *.TOP"
  ' Print #intFile2, " CREDO-TER *.ABR"
  '     TOP- -  
  Dim strVertFantom As String
  strVertFantom = "1         051     100.00           100.00         100.0          999  /TS:""STN1"" /K:KI"
  Print #intFile1, strVertFantom
  '==================================================
    intPntNum = 1000

  For i = 0 To intCnt - 1
    Set pline3dObj = acSelSet.Item(i)
    retCoord = pline3dObj.Coordinates
    For Each varVert In retCoord
        intVCnt = intVCnt + 1
    Next
  
  '     
  ' strLayer = pline3dObj.Layer
  ExportLayerName (pline3dObj.Layer)
  '  ""    1-    
  If pline3dObj.Closed Then  ' =True
     intVCnt = intVCnt + 1
     AnyPnt = pline3dObj.Coordinate(0)
     pline3dObj.AppendVertex AnyPnt
     '  ""  -  
     '    !!!
     pline3dObj.Closed = False
  End If
  '        TOP-
  '  3DPolylines 3 - 1,   Polylines 2 - 1
  For intCrdCnt = 0 To (intVCnt / 3 - 1)
    '     1001,    Sokkia
    intPntNum = intPntNum + 1
    varCord = pline3dObj.Coordinate(intCrdCnt)
    '  X  Y  .  .  -  0  1
    strVert = CStr(intPntNum) & "      001     " & _
              CStr(vbdRoundToDecimal(varCord(1), 3))
    strVert = strVert & Space(35 - Len(strVert)) & _
              CStr(vbdRoundToDecimal(varCord(0), 3))
    '  LWPotylines .  REM!!!    3DPolylines!!!
    strVert = strVert & Space(50 - Len(strVert)) & _
             CStr(vbdRoundToDecimal(varCord(2), 3))
    strVert = strVert & Space(65 - Len(strVert)) & strLayer
    '     ","   "."
    ChangeSeparator
    Print #intFile1, strVert
    strVert2 = "1  " & CStr(intPntNum)
    Print #intFile2, strVert2
  Next
  '     ABR-
  Print #intFile2, " /LE:" & strLayer & " /KL:PLN /KR:1"
  Print #intFile2, "*"
  intVCnt = 0 '   3DPolyline
  Next i
  '===================================================
  '         .
  ThisDrawing.SelectionSets.Item("for_CREDO").Delete
 
 '======================================================
  ' 2-  -       ELEVATION:
 '======================================================
  '      for_CREDO
  Set acSelSet = ThisDrawing.SelectionSets.Add("for_CREDO")
  '   -  (All) - VBA    
  '  ,     
  mode = acSelectionSetAll
  '     SelectionSet
  acSelSet.Select mode
  '    ( : , Entityes)
  intCnt = acSelSet.Count
  '     
  MsgBox "   " & intCnt & " ." _
  & vbCrLf & "   LW(2D)-..."
  '      
  ThisDrawing.SelectionSets.Item("for_CREDO").Clear

  gpCode(0) = 0
  dataValue(0) = "LWPolyline"
  groupCode = gpCode
  dataCode = dataValue

  ' acSelSet.Select mode, groupCode, dataCode
  acSelSet.SelectOnScreen groupCode, dataCode
  '    
  intCnt = acSelSet.Count
  MsgBox "  " & intCnt & " LWPolyline "
  intCnt2 = 1
  ' Print #intFile1, "        :"
  ' Print #intFile1, "         " & CStr(intCnt)
  '==================================================
  '   2D-Line   3D-Line   Elevation
  '   Z-
  ' Dim currElevation As Variant
  ' currElevation = plineObj.Elevation
  
  For i = 0 To intCnt - 1
    Set plineObj = acSelSet.Item(i)
    retCoord = plineObj.Coordinates
    For Each varVert In retCoord
        intVCnt = intVCnt + 1
    Next
  
  '     
  ' strLayer = plineObj.Layer
  ExportLayerName (plineObj.Layer)
  '    
  ' strInfo = "  " & CStr(intVCnt)
  ' Print #intFile1, strInfo
  
  '        TOP-
  '  3DPolylines 3 - 1,   Polylines 2 - 1
  '        Elevation
  codePnt = "001" ' 
  codeRel = "1"  '  
  If plineObj.Elevation = 0 Then
     codePnt = "103" ' 
     codeRel = "0"   '   
  End If
  
  For intCrdCnt = 0 To intVCnt / 2 - 1
    '   
    intPntNum = intPntNum + 1
    varCord = plineObj.Coordinate(intCrdCnt)
    '  X  Y  .  .  -  0  1
    strVert = CStr(intPntNum) & "      " & codePnt & "     " & _
              CStr(vbdRoundToDecimal(varCord(1), 3))
    strVert = strVert & Space(35 - Len(strVert)) & _
              CStr(vbdRoundToDecimal(varCord(0), 3))
    '  LWPotylines    Z  Elevation  !!!
    ' currElevation = plineObj.Elevation
     strVert = strVert & Space(50 - Len(strVert)) & _
             CStr(plineObj.Elevation)
    strVert = strVert & Space(65 - Len(strVert)) & strLayer
    '     ","   "."
    ChangeSeparator
    Print #intFile1, strVert
    strVert2 = "1  " & CStr(intPntNum)
    Print #intFile2, strVert2
  Next
  '     ABR-
  Print #intFile2, " /LE:" & strLayer & " /KL:PLN /KR:" & codeRel
  Print #intFile2, "*"
  intVCnt = 0 '   3DPolyline
  Next i
  '===================================================
  '         .
  ThisDrawing.SelectionSets.Item("for_CREDO").Delete

 '======================================================
  ' 3-  - 3D- - POINTS:
 '======================================================
  '      for_CREDO
  Set acSelSet = ThisDrawing.SelectionSets.Add("for_CREDO")
  '   -  (All) - VBA    
  '  ,     
  mode = acSelectionSetAll
  '     SelectionSet
  acSelSet.Select mode
  '    ( : , Entityes)
  intCnt = acSelSet.Count
  '     
  MsgBox "   " & intCnt & " " _
  & vbCrLf & "   3D-..."
  '      
  ThisDrawing.SelectionSets.Item("for_CREDO").Clear

  gpCode(0) = 0
  dataValue(0) = "Point"

  groupCode = gpCode
  dataCode = dataValue

  ' acSelSet.Select mode, groupCode, dataCode
  acSelSet.SelectOnScreen groupCode, dataCode
  '    
  intCnt = acSelSet.Count
  MsgBox "  " & intCnt & " POINT "
  intCnt2 = 1
  ' Print #intFile1, " "
  ' Print #intFile1, "       :"
  '==================================================
  '    
  ' strInfo = "  " & CStr(intCnt - 1)
  ' Print #intFile1, strInfo

  For i = 0 To intCnt - 1
    Set pointObj = acSelSet.Item(i)
    retCoord = pointObj.Coordinates
  '     
  ' strLayer = pointObj.Layer
  ExportLayerName (pointObj.Layer)
  '        Z
  codePnt = "001" ' 
  codeRel = "R"  '  
  If retCoord(2) = 0 Then
     codePnt = "103" ' 
     codeRel = "8"   '   
  End If
'        TOP-
  '   
  intPntNum = intPntNum + 1
  '  X  Y  .  .  -  0  1
  strVert = CStr(intPntNum) & "      " & codePnt & "     " & _
            CStr(vbdRoundToDecimal(retCoord(1), 3))
  strVert = strVert & Space(35 - Len(strVert)) & _
            CStr(vbdRoundToDecimal(retCoord(0), 3))
  strVert = strVert & Space(50 - Len(strVert)) & _
           CStr(vbdRoundToDecimal(retCoord(2), 3))
  strVert = strVert & Space(65 - Len(strVert)) & strLayer & "  /K:" & codeRel
  '     ","   "."
  ChangeSeparator
  Print #intFile1, strVert
  Next i
  '===================================================
  '         .
  ThisDrawing.SelectionSets.Item("for_CREDO").Delete

 '======================================================
  ' 4-  -   - TEXT:
 '======================================================
  '      for_CREDO
  Set acSelSet = ThisDrawing.SelectionSets.Add("for_CREDO")
  '   -  (All) - VBA    
  '  ,     
  mode = acSelectionSetAll
  '     SelectionSet
  acSelSet.Select mode
  '    ( : , Entityes)
  intCnt = acSelSet.Count
  '     
  MsgBox "   " & intCnt & " ." _
  & vbCrLf & "     ..."
  '      
  ThisDrawing.SelectionSets.Item("for_CREDO").Clear

  gpCode(0) = 0
  ' dataValue(0) = "Line"
  ' dataValue(0) = "Point"
  dataValue(0) = "Text"

  groupCode = gpCode
  dataCode = dataValue

  ' acSelSet.Select mode, groupCode, dataCode
  acSelSet.SelectOnScreen groupCode, dataCode
  '    
  intCnt = acSelSet.Count
  MsgBox "  " & intCnt & " TEXT "
  intCnt2 = 1
  ' Print #intFile1, "         :"
  ' Print #intFile1, "          " & CStr(intCnt)
  '==================================================
  For i = 0 To intCnt - 1
    Set textObj = acSelSet.Item(i)
    retCoord = textObj.InsertionPoint
    For Each varVert In retCoord
        intVCnt = intVCnt + 1
    Next
  
    '     
    ' strLayer = textObj.Layer
    ExportLayerName (textObj.Layer)
    '        TOP-
    '   
    intPntNum = intPntNum + 1
    varCord = retCoord
    '  X  Y  .  .  -  0  1
    strVert = CStr(intPntNum) & "      001     " & _
              CStr(vbdRoundToDecimal(varCord(1), 3))
    strVert = strVert & Space(35 - Len(strVert)) & _
              CStr(vbdRoundToDecimal(varCord(0), 3))
    '   Z=0     ,   
    '    ( )
    InputString = textObj.textString
    FindPointSymbol
    If PointSymbol <> "" Then
    strVert = strVert & Space(50 - Len(strVert)) & textObj.textString
    Else
    strVert = strVert & Space(50 - Len(strVert)) & CStr(0)
    End If
    If PointSymbol <> "" Then
    strVert = strVert & Space(65 - Len(strVert)) & strLayer & "  /K:R"
    Else
    strVert = strVert & Space(65 - Len(strVert)) & strLayer & "  /K:Rp"
    End If
    '     ","   "."
    ChangeSeparator
    Print #intFile1, strVert
    intVCnt = 0 '   Text
  Next i
  '===================================================
  '         .
  ThisDrawing.SelectionSets.Item("for_CREDO").Delete

 '======================================================
  ' 5-  -   - LINES:
 '======================================================
  '      for_CREDO
  Set acSelSet = ThisDrawing.SelectionSets.Add("for_CREDO")
  '   -  (All) - VBA    
  '  ,     
  mode = acSelectionSetAll
  '     SelectionSet
  acSelSet.Select mode
  '    ( : , Entityes)
  intCnt = acSelSet.Count
  '     
  MsgBox "   " & intCnt & " ." _
  & vbCrLf & "   2D-..."
  '      
  ThisDrawing.SelectionSets.Item("for_CREDO").Clear

  gpCode(0) = 0
  dataValue(0) = "Line"

  groupCode = gpCode
  dataCode = dataValue

  ' acSelSet.Select mode, groupCode, dataCode
  acSelSet.SelectOnScreen groupCode, dataCode
  '    
  intCnt = acSelSet.Count
  MsgBox "  " & intCnt & " LINE "
  intCnt2 = 1
  ' Print #intFile1, " "
  ' Print #intFile1, "       :"
  '==================================================
  '    
  ' strInfo = "  " & CStr(intCnt - 1)
  ' Print #intFile1, strInfo

  For i = 0 To intCnt - 1
    Set lineObj = acSelSet.Item(i)
    retCoordStart = lineObj.startPoint
    retCoordEnd = lineObj.endPoint
    '     
    ' strLayer = lineObj.Layer
    ExportLayerName (lineObj.Layer)
    '        TOP-
    '   
    
    ' 1-  
    intPntNum = intPntNum + 1
    '  X  Y  .  .  -  0  1
    strVert = CStr(intPntNum) & "      103     " & _
              CStr(vbdRoundToDecimal(retCoordStart(1), 3))
    strVert = strVert & Space(35 - Len(strVert)) & _
              CStr(vbdRoundToDecimal(retCoordStart(0), 3))
    strVert = strVert & Space(50 - Len(strVert)) & _
             CStr(vbdRoundToDecimal(retCoordStart(2), 3))
    strVert = strVert & Space(65 - Len(strVert)) & strLayer
    '     ","   "."
    ChangeSeparator
    Print #intFile1, strVert
        '     ABR-
    strVert2 = "1  " & CStr(intPntNum)
    Print #intFile2, strVert2
    
    ' 2-  
    intPntNum = intPntNum + 1
    '  X  Y  .  .  -  0  1
    strVert = CStr(intPntNum) & "      103     " & _
              CStr(vbdRoundToDecimal(retCoordEnd(1), 3))
    strVert = strVert & Space(35 - Len(strVert)) & _
              CStr(vbdRoundToDecimal(retCoordEnd(0), 3))
    strVert = strVert & Space(50 - Len(strVert)) & _
             CStr(vbdRoundToDecimal(retCoordEnd(2), 3))
    strVert = strVert & Space(65 - Len(strVert)) & strLayer
    '     ","   "."
    ChangeSeparator
    Print #intFile1, strVert
    '     ABR-
    strVert2 = "1  " & CStr(intPntNum)
    Print #intFile2, strVert2
    Print #intFile2, " /LE:" & strLayer & " /KL:PLN /KR:0"
    Print #intFile2, "*"
  Next i
  '===================================================
  '   TOP  ABR
  Close intFile1
  Close intFile2
  '        ...
  ThisDrawing.SelectionSets.Item("for_CREDO").Delete
  '    -    
  RestoreLayerName
    '       (MsgBox)    :
    MsgBox "Export_ACAD_to_CREDO -  .         -  *.TOP  *.ABR." _
    & vbCrLf & "        Credo-TER(MIX)      ->-." _
    & vbCrLf & " " _
    & vbCrLf & "   cadforyou.spb.ru  ,         ...  .." _
    & vbCrLf & " ,  ,    .   - , !" _
    & vbCrLf & " " _
    & vbCrLf & "  ,     .   .     ." _
    & vbCrLf & "    www.cad.dp.ua -   (   )     VBA   ." _
    & vbCrLf & " " _
    & vbCrLf & " ! , !" _
    & vbCrLf & " , , sklimkin@comail.ru ", vbExclamation

  '     !
End Sub

